package org.zheng.demo;

public class CallingGetClass {

	private String instanceVar = " default";
	private static String staticVar;

	static {
		staticVar = " Class level data";
	}

	public static void main(String[] args) {
		CallingGetClass demoObj = new CallingGetClass();
		System.out.println("demoObj.getClass()=" + demoObj.getClass() + demoObj.instanceVar);
		System.out.println("CallingGetClass.class=" + CallingGetClass.class);
		System.out.println("CallingGetClass.staticVar=" + CallingGetClass.staticVar);

		CallingGetClass demoObj2 = new CallingGetClass();
		demoObj2.instanceVar = " changed";
		System.out.println("demoObj2.getClass()=" + demoObj2.getClass() + demoObj2.instanceVar);

		System.out.println("OuterClass.MyStaticClass.class=" + OuterClass.MyStaticClass.class);
		System.out.println("OuterClass.getStaticIntValue()=" + OuterClass.getStaticIntValue());

		demoObj.nonStaticMethod();
		System.out.println("demoObj.staticVar()=" + CallingGetClass.staticVar);
		System.out.println("denoObj.instanceVar()=" + demoObj.instanceVar);

		fixedStaticMethod(demoObj2);
		System.out.println("demoObj2.staticVar()=" + CallingGetClass.staticVar);
		System.out.println("demoObj2.instanceVar()=" + demoObj2.instanceVar);

	}

	public static void staticMethod() {
		System.out.println(this.getClass());
		instanceVar = "Changed inside staticMethod";
		staticVar = "Changed inside staticMethod";
	}

	public static void fixedStaticMethod(CallingGetClass obj) {
		System.out.println(obj.getClass());
		obj.instanceVar = "Changed inside fixedStaticMethod";
		staticVar = "Changed inside fixedStaticMethod";
	}

	public void nonStaticMethod() {
		System.out.println(this.getClass());
		instanceVar = "Changed inside nonStaticMethod";
		staticVar = "Changed inside nonStaticMethod";
	}
}
